#
# step1.rb
#
# $Id: step1.rb,v 1.1 2000/11/21 03:15:29 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include NMath


nmax = 201
imax = 5
len_2 = 5

x  = 0
y0 = 1
y1 = 2
y2 = 3
y3 = 4

z1 = NArray.sfloat(nmax, len_2)
# 2nd Dimension
#    0: X, 1: Y0, 2: Y1, 3:Y2 4: Y3    in step1.f

a = []

#-- data ----
for m in 1..imax
  tm = (2*m - 1)*PI
  a[m-1] = (-1.0)**m * 2/tm
end

for n in 1..nmax
  z1[n-1,x] = 1.0*(n-1)/(nmax-1)
  tn = 2*PI*z1[n-1,x]

  z1[n-1,y0] =
    if (tn < PI/2 || tn >= PI*3/2) then 0.0 else 1.0 end
  z1[n-1,y1] = 0.5 + a[0]*cos(tn)
  z1[n-1,y2] = 0.5
  z1[n-1,y3] = 0.5

  for k in 1..imax
    tk = 2*k - 1
    tc = a[k-1]*cos(tk*tn)

    z1[n-1,y2] = z1[n-1,y2] +
      if (k <= 3) then tc else 0 end
    z1[n-1,y3] = z1[n-1,y3] + tc
  end
end

#-- graph ----
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws
grfrm

x  = z1[true,x]
y0 = z1[true,y0]
y1 = z1[true,y1]
y2 = z1[true,y2]
y3 = z1[true,y3]

usspnt(nmax, x, y0)
usspnt(nmax, x, y1)
usspnt(nmax, x, y2)
usspnt(nmax, x, y3)

uspfit
grstrf

ussttl('FREQUENCY', '/DAY', 'RESPONSE', '')
usdaxs

uulin(nmax, x, y0)

uuslnt(2)
uuslni(3)
uulin(nmax, x, y1)

uuslnt(3)
uulin(nmax, x, y2)

uuslnt(4)
uulin(nmax, x, y3)

grcls

